(function(g){var window=this;var I1=function(a){a.isActive()||a.start()},J1=function(a){var b={languageCode:a.languageCode,
languageName:a.languageName,displayName:g.PH(a),kind:a.kind,name:a.name,id:a.id,is_servable:a.i,is_default:a.isDefault,is_translateable:a.isTranslateable,vss_id:a.vssId};a.translationLanguage&&(b.translationLanguage=a.translationLanguage);return b},K1=function(a){return a.translationLanguage?a.translationLanguage.languageCode:a.languageCode},AEa=function(a,b){var c=new g.OH;
c.languageCode=a.languageCode;c.languageName=a.languageName;c.name=a.name;c.kind=a.kind;c.isDefault=!1;c.i=a.i;c.isTranslateable=a.isTranslateable;c.vssId=a.vssId;c.url=a.url;c.translationLanguage=b;return c},BEa=function(){this.l=[];
this.i=[]},L1=function(a,b){return b?a.i.concat(a.l):a.i},M1=function(a,b){switch(b.kind){case "asr":CEa(b,a.l);
break;default:CEa(b,a.i)}},CEa=function(a,b){g.$a(b,function(c){return c?a.toString()===c.toString():!1})||b.push(a)},N1=function(){g.C.call(this);
this.l=new BEa;this.C=[]},O1=function(a,b,c){N1.call(this,a);
this.audioTrack=c;this.i=null;this.C=b.kH},P1=function(){this.segments=[]},DEa=function(a,b){var c=g.tb(a.segments,b);
0<=c||0>c&&1===(-c-1)%2||(c=-c-1,0<c&&1===b-a.segments[c-1]&&c<a.segments.length&&1===a.segments[c]-b?(g.gb(a.segments,c),g.gb(a.segments,c-1)):0<c&&1===b-a.segments[c-1]?a.segments[c-1]=b:c<a.segments.length&&1===a.segments[c]-b?a.segments[c]=b:(g.qb(a.segments,c,0,b),g.qb(a.segments,c+1,0,b)))},Q1=function(a,b,c,d,e,f){g.C.call(this);
this.policy=a;this.player=b;this.U=c;this.G=d;this.C=e;this.K=f;this.T=this.player.P();this.B=new P1;this.l=this.u=this.i=null;this.I=new g.I(this.EE,1E3,this);this.events=new g.aO(this);g.D(this,this.I);g.D(this,this.events);this.events.L(b,"SEEK_COMPLETE",this.mB);this.mB();this.EE()},EEa=function(a,b){var c=g.Lx(g.Rx(b,a.policy,{})),d={format:"RAW",
withCredentials:!0};a.C&&(d.responseType="arraybuffer");a.l=g.zt(c,d,3,100).then(function(e){a:{a.ka();if(a.u){var f=!(a.C?e.response:e.responseText)||400<=e.status,h=g.$A(e);if(h){e=g.Rx(a.u,a.policy,{});f=a.u;g.Fy(f.l,e,h);f.requestId=e.get("req_id");EEa(a,a.u);break a}f||null==a.G||(h=a.u.i[0],a.C?a.G(e.response,1E3*(h.startTime+a.player.oc())):a.G(e.responseText,1E3*(h.startTime+a.player.oc())))}a.u=null;a.l=null}});
a.u=b;DEa(a.B,a.u.i[0].na)},R1=function(a,b){N1.call(this,b.P());
this.i=a;this.F=b;this.u=null;this.B=!1;this.G=g.rD(this.F.P())&&!this.i.isManifestless},FEa=function(a,b){var c=[],d;
for(d in a.i.i)if(a.i.i.hasOwnProperty(d)){var e=a.i.i[d];if(g.jO(e,b||null)){var f="en",h="English",l=".en",m="";if(e=e.info.captionTrack)f=e.languageCode,h=e.displayName,l=e.vssId,m=e.kind;c.push(new g.OH({id:d,languageCode:f,languageName:h,is_servable:!0,is_default:!0,is_translateable:!1,vss_id:l,kind:m}))}}return c},GEa=function(a,b){return null!=b&&b in a.i.i?a.i.i[b]:null},HEa=function(a,b,c){var d=[],e;
for(e in a.i.i)if(a.i.i.hasOwnProperty(e)){var f=a.i.i[e];if(g.jO(f,c||null)){var h=f.info.captionTrack;h&&h.languageCode===b&&d.push(f)}}return d.length?d[0]:null},S1=function(a,b,c,d,e){N1.call(this,e||null);
this.videoId=b;this.dE=d;this.B={};this.i=null;b=c||g.Hp(a).hl||"";b=b.split("_").join("-");this.u=g.Jp(a,{hl:b})},T1=function(a){if(!IEa.test(a))throw Error("'"+a+"' is not a valid hex color");
4==a.length&&(a=a.replace(JEa,"#$1$1$2$2$3$3"));a=a.toLowerCase();a=parseInt(a.substr(1),16);return[a>>16,a>>8&255,a&255]},U1=function(a,b,c,d,e,f){var h={};
g.Qa(h,b);g.Qa(h,a.params);g.Qa(h,c);var l={};g.Qa(l,b.Cc);a.params.Cc&&g.Qa(l,a.params.Cc);g.Qa(l,c.Cc);h.Cc=l;g.V.call(this,{D:"div",J:"caption-window",R:{id:"caption-window-"+a.id,dir:1===h.Qe?"rtl":"ltr",tabindex:"0","aria-live":"assertive",lang:h.lang},N:[{D:"span",J:"captions-text",R:{style:"word-wrap: normal; display: block;"}}]});this.C=[];this.Z=!1;this.l=a;this.fa=this.ba=null;this.playerWidth=e;this.playerHeight=f;this.G=null;this.maxWidth=.96*e;this.wa=.96*f;this.i=h;this.jb=c;this.B=
this.ea("captions-text");this.Ta=""!==this.B.style.getPropertyValue("box-decoration-break")||""!==this.B.style.getPropertyValue("-webkit-box-decoration-break");this.da=d/360*16;this.type=0;this.Aa=this.da*KEa(l);a=new g.Wt(this.element,!0);g.D(this,a);a.subscribe("dragstart",this.kJ,this);a.subscribe("dragmove",this.jJ,this);a.subscribe("dragend",this.iJ,this);this.Ha=this.Ea=0;b="";this.i.windowOpacity&&(a=T1(this.i.windowColor),b="rgba("+a[0]+","+a[1]+","+a[2]+","+this.i.windowOpacity+")");a={"background-color":b,
display:!1===this.i.isVisible?"none":"","text-align":LEa[this.i.textAlign]};this.Ta&&(a["border-radius"]=b?this.Aa/8+"px":"");if(this.u=2===this.l.params.Qe||3===this.l.params.Qe)b=this.element,c="vertical-rl",1===this.i.iA&&(c="vertical-lr"),g.ve&&(c="vertical-lr"===c?"tb-lr":"tb-rl"),g.vg(b,"-o-writing-mode",c),g.vg(b,"-webkit-writing-mode",c),g.vg(b,"writing-mode",c),g.vg(b,"text-orientation","upright"),g.K(b,"ytp-vertical-caption"),3===this.l.params.Qe&&(g.vg(b,"text-orientation",""),g.vg(b,"transform",
"rotate(180deg)"));g.vg(this.element,a);switch(this.i.Uh){case 0:case 1:case 2:g.K(this.element,"ytp-caption-window-top");break;case 6:case 7:case 8:g.K(this.element,"ytp-caption-window-bottom")}},KEa=function(a){var b=1+.25*(a.fontSizeIncrement||0);
if(0===a.offset||2===a.offset)b*=.8;return b},MEa=function(a,b){var c={},d=b.background?b.background:a.i.Cc.background;
if(null!=b.backgroundOpacity||b.background){var e=null!=b.backgroundOpacity?b.backgroundOpacity:a.i.Cc.backgroundOpacity;d=T1(d);c.background="rgba("+d[0]+","+d[1]+","+d[2]+","+e+")";a.Ta&&(c["box-decoration-break"]="clone",c["border-radius"]=a.Aa/8+"px")}if(null!=b.fontSizeIncrement||null!=b.offset)c["font-size"]=a.da*KEa(b)+"px";d=1;e=b.color||a.i.Cc.color;if(b.color||null!=b.textOpacity)e=T1(e),d=null==b.textOpacity?a.i.Cc.textOpacity:b.textOpacity,e="rgba("+e[0]+","+e[1]+","+e[2]+","+d+")",c.color=
e,c.fill=e;var f=b.charEdgeStyle;0===f&&(f=void 0);if(f){e="rgba(34, 34, 34, "+d+")";var h="rgba(204, 204, 204, "+d+")";b.hx&&(h=e=b.hx);var l=a.da/16/2,m=Math.max(l,1),n=Math.max(2*l,1),p=Math.max(3*l,1),r=Math.max(5*l,1);d=[];switch(f){case 4:for(;p<=r;p+=l)d.push(n+"px "+n+"px "+p+"px "+e);break;case 1:n=2<=window.devicePixelRatio?.5:1;for(f=m;f<=p;f+=n)d.push(f+"px "+f+"px "+e);break;case 2:d.push(m+"px "+m+"px "+h);d.push("-"+m+"px -"+m+"px "+e);break;case 3:for(p=0;5>p;p++)d.push("0 0 "+n+"px "+
e)}c["text-shadow"]=d.join(", ")}e="";switch(b.fontFamily){case 1:e='"Courier New", Courier, "Nimbus Mono L", "Cutive Mono", monospace';break;case 2:e='"Times New Roman", Times, Georgia, Cambria, "PT Serif Caption", serif';break;case 3:e='"Deja Vu Sans Mono", "Lucida Console", Monaco, Consolas, "PT Mono", monospace';break;case 5:e='"Comic Sans MS", Impact, Handlee, fantasy';break;case 6:e='"Monotype Corsiva", "URW Chancery L", "Apple Chancery", "Dancing Script", cursive';break;case 7:e=g.hq()?'"Carrois Gothic SC", sans-serif-smallcaps':
'"Arial Unicode Ms", Arial, Helvetica, Verdana, "Marcellus SC", sans-serif';break;case 0:case 4:e='"YouTube Noto", Roboto, "Arial Unicode Ms", Arial, Helvetica, Verdana, "PT Sans Caption", sans-serif'}e&&(c["font-family"]=e);e=b.offset;null==e&&(e=a.i.Cc.offset);switch(e){case 0:c["vertical-align"]="sub";break;case 2:c["vertical-align"]="super"}7===b.fontFamily&&(c["font-variant"]="small-caps");b.bold&&(c["font-weight"]="bold");b.fi&&(c["font-style"]="italic");b.underline&&(c["text-decoration"]="underline");
b.LL&&(c.visibility="hidden");1===b.YD&&a.u&&(c["text-combine-upright"]="all",c["text-orientation"]="mixed",e=g.wD||g.cs,3===a.l.params.Qe?c.transform=e?"rotate(90deg)":"rotate(180deg)":e&&(c.transform="rotate(-90deg)"));if(1===b.Ai||2===b.Ai||3===b.Ai||4===b.Ai||5===b.Ai)if(g.wD)c["font-weight"]="bold";else switch(c["text-emphasis-style"]="filled circle",c["text-emphasis-color"]="currentcolor",c["webkit-text-emphasis"]="filled circle",b.Ai){case 4:case 3:c["text-emphasis-position"]="under left";
c["webkit-text-emphasis-position"]="under left";break;case 5:case 2:c["text-emphasis-position"]="over right",c["webkit-text-emphasis-position"]="over right"}return c},NEa=function(a){a.G=g.Ce("SPAN");
g.vg(a.G,{display:"block"});g.K(a.G,"caption-visual-line");a.B.appendChild(a.G)},OEa=function(a,b){var c=g.Ce("SPAN");
g.vg(c,{display:"inline-block","white-space":"pre-wrap"});g.vg(c,MEa(a,b));c.classList.add("ytp-caption-segment");a.G.appendChild(c);c.previousElementSibling&&(g.vg(c.previousElementSibling,{"border-top-right-radius":"0","border-bottom-right-radius":"0"}),g.vg(c,{"border-top-left-radius":"0","border-bottom-left-radius":"0"}));return c},PEa=function(a,b,c){a.Z=a.Z||!!c;
var d={};g.Qa(d,a.i.Cc);g.Qa(d,c||b.i);g.Qa(d,a.jb.Cc);(c=!a.G)&&NEa(a);for(var e=a.ba&&a.fa&&g.Pb(d,a.fa)?a.ba:OEa(a,d),f="string"===typeof b.text,h=f?b.text.split("\n"):[b.text],l=0;l<h.length;l++){var m=0<l||!b.append,n=h[l];m&&!c?(NEa(a),e=OEa(a,d)):m&&c&&(c=!1);n&&(e.appendChild(f?g.De(n):n),f||"RUBY"!==n.tagName||4!==n.childElementCount||g.wD||!g.zg(n.children[2],"text-emphasis")||(m=a.u?"padding-right":"padding-top",g.zg(n.children[2],"text-emphasis-position")&&(m=a.u?"padding-left":"padding-bottom"),
g.xe?g.vg(e,m,"1em"):g.vg(e,m,"0.5em")))}a.fa=d;a.ba=e;a.C.push(b)},V1=function(a,b,c,d,e,f,h){U1.call(this,a,b,c,d,e,f,h);
this.type=1},W1=function(a,b,c,d,e,f,h){U1.call(this,a,b,c,d,e,f,h);
this.type=2;this.I=[];this.U=this.K=this.ha=0;this.V=NaN;this.Na=0;this.Ua=null;this.ia=new g.I(this.MO,433,this);g.K(this.element,"ytp-caption-window-rollup");g.D(this,this.ia);g.vg(this.element,"overflow","hidden")},QEa=function(a,b){if(!b)return"";
a.u&&1!==a.l.params.iA&&(b*=-1);return"translate"+(a.u?"X":"Y")+"("+b+"px)"},REa=function(a){a.I=Array.from(document.getElementsByClassName("caption-visual-line"));
for(var b=a.l.params.wk,c=0,d=0,e=a.I.length-1;c<b&&-1<e;){var f=a.I[e];d+=a.u?f.offsetWidth:f.offsetHeight;c++;e--}a.I.length<b&&(d*=b/a.I.length);a.K=d;b=Math;c=b.max;isNaN(a.V)&&((d=a.i.Yk)?(e=g.Ce("SPAN"),g.Ke(e,"\u2013".repeat(d)),g.vg(e,MEa(a,a.i.Cc)),a.B.appendChild(e),a.V=e.offsetWidth,a.B.removeChild(e)):a.V=0);d=a.B;a.U=c.call(b,a.V,a.Na,(a.u?d.offsetHeight:d.offsetWidth)+1)},SEa=function(a,b){REa(a);
var c=a.I.reduce(function(e,f){return(a.u?f.offsetWidth:f.offsetHeight)+e},0);
c=a.K-c;if(c!==a.ha){var d=0<c&&0===a.ha;b||isNaN(c)||d||(g.K(a.element,"ytp-rollup-mode"),g.ln(a.ia));g.vg(a.B,"transform",QEa(a,c));a.ha=c}REa(a)},X1=function(a,b,c,d,e,f,h){f=void 0===f?!1:f;
h=void 0===h?null:h;g.oG.call(this,a,a+b,{priority:c,namespace:"captions"});this.windowId=d;this.text=e;this.append=f;this.i=h},Y1=function(a,b,c,d,e){g.oG.call(this,a,a+b,{priority:c,
namespace:"captions"});this.id=d;this.params=e;this.i=[]},TEa=function(a){var b="_"+Z1++;
return new Y1(0,0x8000000000000,0,b,a)},VEa=function(a,b,c,d,e,f,h){var l=f[0],m=h[l.getAttribute("p")];
if(1===m.xd){var n=f[1],p=f[2];f=f[3];l.getAttribute("t");n.getAttribute("t");p.getAttribute("t");f.getAttribute("t");l.getAttribute("p");n.getAttribute("p");f.getAttribute("p");h=h[p.getAttribute("p")];l=UEa(l.textContent,n.textContent,p.textContent,f.textContent,h);return new X1(a,b,e,c,l,d,m)}switch(m.xd){case 9:case 10:m.Ai=1;break;case 11:m.Ai=2;break;case 12:m.Ai=3;break;case 13:m.Ai=4;break;case 14:m.Ai=5}return new X1(a,b,e,c,l.textContent||"",d,m)},UEa=function(a,b,c,d,e){var f=g.hq(),h=
f?g.Ce("DIV"):g.Ce("RUBY"),l=g.Ce("SPAN");
l.textContent=a;h.appendChild(l);a=f?g.Ce("DIV"):g.Ce("RP");a.textContent=b;h.appendChild(a);b=f?g.Ce("DIV"):g.Ce("RT");b.textContent=c;h.appendChild(b);c=e.xd;if(10===c||11===c||12===c||13===c||14===c)if(g.vg(b,"text-emphasis-style","filled circle"),g.vg(b,"text-emphasis-color","currentcolor"),g.vg(b,"webkit-text-emphasis","filled circle"),11===e.xd||13===e.xd)g.vg(b,"webkit-text-emphasis-position","under left"),g.vg(b,"text-emphasis-position","under left");c=!0;if(4===e.xd||7===e.xd||12===e.xd||
14===e.xd)g.vg(h,"ruby-position","over"),g.vg(h,"-webkit-ruby-position","before");else if(5===e.xd||6===e.xd||11===e.xd||13===e.xd)g.vg(h,"ruby-position","under"),g.vg(h,"-webkit-ruby-position","after"),c=!1;e=f?g.Ce("DIV"):g.Ce("RP");e.textContent=d;h.appendChild(e);f&&(d=c,g.vg(h,{display:"inline-block",position:"relative"}),f=h.firstElementChild.nextElementSibling,g.vg(f,"display","none"),f=f.nextElementSibling,g.vg(f,{"font-size":"0.5em","line-height":"1.2em","text-align":"center",position:"absolute",
left:"50%",transform:"translateX(-50%)",width:"400%"}),g.vg(h.lastElementChild,"display","none"),d?(g.vg(h,"padding-top","0.6em"),g.vg(f,"top","0")):(g.vg(h,"padding-bottom","0.6em"),g.vg(f,"bottom","0")));return h},$1=function(){g.C.apply(this,arguments)},a2=function(a){$1.call(this);
this.C=a;this.B={};this.T={};this.U={};this.G="_"+Z1++;this.K={};this.l=this.i=null;this.I=!0},b2=function(a,b){var c=a.getAttribute(b);
if(null!=c)return Number(c)},c2=function(a,b){var c=a.getAttribute(b);
if(null!=c)return"1"===c},d2=function(a,b){var c=b2(a,b);
return void 0!==c?c:null},f2=function(a,b){var c=a.getAttribute(b);
if(null!=c)return e2.test(c),c},WEa=function(a,b){var c={},d=b.getAttribute("ws");
g.Qa(c,d?a.U[d]:a.C);d=d2(b,"mh");null!=d&&(c.gp=d);d=d2(b,"ju");null!=d&&(c.textAlign=d);d=d2(b,"pd");null!=d&&(c.Qe=d);d=d2(b,"sd");null!=d&&(c.iA=d);d=f2(b,"wfc");null!=d&&(c.windowColor=d);d=b2(b,"wfo");void 0!==d&&(c.windowOpacity=d/255);return c},XEa=function(a,b){var c={},d=b.getAttribute("wp");
d&&g.Qa(c,a.T[d]);d=d2(b,"ap");null!=d&&(c.Uh=d);d=b2(b,"cc");null!=d&&(c.Yk=d);d=b2(b,"ah");null!=d&&(c.Vg=d);d=b2(b,"rc");null!=d&&(c.wk=d);d=b2(b,"av");null!=d&&(c.Ci=d);return c},YEa=function(a,b,c,d){var e={};
g.Qa(e,XEa(a,b));g.Qa(e,WEa(a,b));d?g.Pb(e,a.C)?(d=a.G,e=a.C):d="_"+Z1++:d=b.getAttribute("id")||"_"+Z1++;a=b2(b,"t")+c;b=b2(b,"d")||0x8000000000000;if(2===e.Qe||3===e.Qe)c=e.wk,e.wk=e.Yk,e.Yk=c;return new Y1(a,b,0,d,e)},g2=function(a){$1.call(this);
this.G=a;this.i=new Map;this.B=new Map;this.C=new Map;this.l=new Map},h2=function(a){a=g.Zd(Math.round(a),0,16777215).toString(16).toUpperCase();
return"#000000".substr(0,7-a.length)+a},ZEa=function(a,b,c,d,e){0===d&&(d=0x8000000000000);
var f={};b.wpWinPosId&&Object.assign(f,a.B.get(b.wpWinPosId));b.wsWinStyleId&&Object.assign(f,a.C.get(b.wsWinStyleId));a=b.rcRowCount;void 0!==a&&(f.wk=a);b=b.ccColCount;void 0!==b&&(f.Yk=b);if(2===f.Qe||3===f.Qe)b=f.wk,f.wk=f.Yk,f.Yk=b;return new Y1(c,d,0,e,f)},j2=function(){this.u=this.time=this.mode=this.l=0;
this.B=new i2(this);this.C=new i2(this);this.i=[];this.clear()},aFa=function(a,b,c){if(255===a&&255===b||!a&&!b)return{Hm:a,
Uk:b,result:0};a=$Ea[a];b=$Ea[b];if(a&128){var d;if(d=!(b&128))d=b,d=c.isValid()&&c.Uk===d;if(d)return{Hm:a,Uk:b,result:1}}else if(b&128&&1<=a&&31>=a)return{Hm:a,Uk:b,result:2};return{Hm:a,Uk:b,result:3}},cFa=function(a,b,c,d){255===b&&255===c||!b&&!c?(45===++a.u&&a.reset(),a.B.l.clear(),a.C.l.clear()):(a.u=0,bFa(a.B,b,c,d))},dFa=function(a,b){a.i.sort(function(e,f){var h=e.time-f.time;
return 0===h?e.order-f.order:h});
for(var c=g.q(a.i),d=c.next();!d.done;d=c.next())d=d.value,a.time=d.time,0===d.type?cFa(a,d.DC,d.EC,b):1===d.type&&a.l&496&&bFa(a.C,d.DC,d.EC,b);a.i.length=0},k2=function(){this.type=0},l2=function(){this.state=this.Uk=this.Hm=0},eFa=function(){this.timestamp=this.i=0},m2=function(a){this.C=a;
this.u=[];this.i=this.l=this.row=0;this.style=new k2;for(a=this.B=0;15>=a;a++){this.u[a]=[];for(var b=0;32>=b;b++)this.u[a][b]=new eFa}},n2=function(a,b){if(3===a.style.type){for(var c=0,d=0,e=a.C.time+0,f="",h="",l=e,m=1;15>=m;++m){for(var n=!1,p=d?d:1;32>=p;++p){var r=a.u[m][p];
if(0!==r.i){0===c&&(c=m,d=p);n=String.fromCharCode(r.i);var t=r.timestamp;t<e&&(e=t);r.timestamp=l;h&&(f+=h,h="");f+=n;n=!0}if((0===r.i||32===p)&&n){h="\n";break}else if(d&&!n)break}if(c&&!n)break}f&&b.B(c,d,e,l,f)}else for(d=c=0,f=e=a.C.time+0,h=1;15>=h;++h)for(l="",m=1;32>=m;++m)if(p=a.u[h][m],r=p.i,0!==r&&(0===c&&(c=h,d=m),n=String.fromCharCode(r),t=p.timestamp,t<=e&&(e=t),l+=n,p.reset()),32===m||0===r)l&&b.B(c,d,e,f,l),e=f,l="",d=c=0},jFa=function(a,b){switch(a){case 0:return fFa[(b&127)-32];
case 1:return gFa[b&15];case 2:return hFa[b&31];case 3:return iFa[b&31]}return 0},o2=function(a){return a.u[a.row][a.l]},p2=function(a,b,c){2<=b&&1<a.l&&(--a.l,o2(a).i=0);
var d=o2(a);d.timestamp=a.C.time+0;d.i=jFa(b,c);32>a.l&&a.l++},kFa=function(a,b,c,d){for(var e=0;e<d;e++)for(var f=0;32>=f;f++){var h=a.u[b+e][f],l=a.u[c+e][f];
h.i=l.i;h.timestamp=l.timestamp}},q2=function(a,b,c){for(var d=0;d<c;d++)for(var e=0;32>=e;e++)a.u[b+d][e].reset()},r2=function(a){a.row=0<a.i?a.i:1;
a.l=1;q2(a,0,15)},s2=function(a){this.u=a;
this.C=0;this.style=new k2;this.G=new m2(this.u);this.I=new m2(this.u);this.text=new m2(this.u);this.l=this.G;this.B=this.I;this.i=this.l},t2=function(a,b,c){var d=a.l,e=!1;
switch(a.style.get()){case 4:case 1:case 2:4===a.style.get()&&0<d.i||(n2(d,c),r2(a.l),r2(a.B),d.row=15,d.i=b,e=!0)}a.style.set(3);a.i=d;a.i.style=a.style;a.u.mode=1<<d.B;e?d.l=1:d.i!==b&&(d.i>b?(n2(d,c),q2(d,d.row-d.i,b)):d.row<b&&(b=d.i),d.i=b)},lFa=function(a){a.style.set(1);
a.i=a.B;a.i.i=0;a.i.style=a.style;a.u.mode=1<<a.i.B},mFa=function(a){a.style.set(4);
a.i=a.text;a.i.style=a.style;a.u.mode=1<<a.i.B},i2=function(a){this.i=a;
this.C=0;this.u=new s2(this.i);this.G=new s2(this.i);this.l=new l2;this.B=this.u},bFa=function(a,b,c,d){a.l.update();
b=aFa(b,c,a.l);switch(b.result){case 0:return;case 1:case 2:return}var e=b.Hm;c=b.Uk;if(32<=e||!e)a.i.mode&a.i.l&&(b=e,b&128&&(b=127),c&128&&(c=127),a=a.B.i,b&96&&p2(a,0,b),c&96&&p2(a,0,c),0!==b&&0!==c&&3===a.style.type&&n2(a,d));else if(e&16)a:if(!a.l.matches(e,c)&&(b=a.l,b.Hm=e,b.Uk=c,b.state=2,b=e&8?a.G:a.u,a.B=b,a.i.mode=1<<(a.C<<2)+(b.C<<1)+(4===b.style.type?1:0),(a.i.mode|1<<(a.C<<2)+(b.C<<1)+(4!==b.style.type?1:0))&a.i.l))if(c&64){d=[11,11,1,2,3,4,12,13,14,15,5,6,7,8,9,10][(e&7)<<1|c>>5&1];
a=c&16?4*((c&14)>>1):0;c=b.i;switch(b.style.get()){case 4:d=c.row;break;case 3:if(d!==c.row){if(d<c.i&&(d=c.i,d===c.row))break;var f=1+c.row-c.i,h=1+d-c.i;kFa(c,h,f,c.i);b=f;e=c.i;h<f?(f=h+e-f,0<f&&(b+=f,e-=f)):(f=f+e-h,0<f&&(e-=f));q2(c,b,e)}}c.row=d;c.l=a+1}else switch(e&7){case 1:switch(c&112){case 32:p2(b.i,0,32);break a;case 48:57===c?(d=b.i,o2(d).i=0,32>d.l&&d.l++):p2(b.i,1,c&15)}break;case 2:c&32&&p2(b.i,2,c&31);break;case 3:c&32&&p2(b.i,3,c&31);break;case 4:case 5:if(32<=c&&47>=c)switch(c){case 32:lFa(b);
break;case 33:d=b.i;1<d.l&&(--d.l,o2(d).i=0);break;case 36:d=b.i;b=o2(d);for(a=0;15>=a;a++)for(c=0;32>=c;c++)if(d.u[a][c]===b){for(;32>=c;c++)d.u[a][c].reset();break}break;case 37:t2(b,2,d);break;case 38:t2(b,3,d);break;case 39:t2(b,4,d);break;case 40:p2(b.i,0,32);break;case 41:b.style.set(2);b.i=b.l;b.i.i=0;b.i.style=b.style;b.u.mode=1<<b.i.B;break;case 42:d=b.text;d.i=15;d.style.set(4);r2(d);mFa(b);break;case 43:mFa(b);break;case 44:a=b.l;switch(b.style.get()){case 1:case 2:case 3:n2(a,d)}q2(a,
0,15);break;case 45:b:{a=b.i;switch(b.style.get()){default:case 2:case 1:break b;case 4:if(15>a.row){++a.row;a.l=1;break b}case 3:}2>a.i&&(a.i=2,a.row<a.i&&(a.row=a.i));b=a.row-a.i+1;n2(a,d);kFa(a,b,b+1,a.i-1);q2(a,a.row,1)}break;case 46:q2(b.B,0,15);break;case 47:n2(b.l,d),b.B.updateTime(b.u.time+0),d=b.B,b.B=b.l,b.l=d,lFa(b)}break;case 7:switch(c){case 33:case 34:case 35:d=b.i,32<(d.l+=c&3)&&(d.l=32)}}},nFa=function(){},u2=function(a,b,c){this.I=a;
this.G=c;this.version=this.C=this.u=this.byteOffset=0;this.i=new DataView(this.I);this.l=[]},v2=function(a){var b=a.byteOffset;
a.byteOffset+=1;return a.i.getUint8(b)},w2=function(a){var b=a.byteOffset;
a.byteOffset+=4;return a.i.getUint32(b)},x2=function(a,b){$1.call(this);
this.l=a;this.B=b;this.track="CC3"===this.B.languageName?4:0;this.i=new j2;this.i.l=1<<this.track},y2=function(a){if("string"===typeof a)return!1;
a=new u2(a,8,0);return oFa(a)},oFa=function(a){if(!(a.byteOffset<a.i.byteLength)||1380139777!==w2(a))return!1;
a.version=v2(a);if(1<a.version)return!1;v2(a);v2(a);v2(a);return!0},z2=function(){$1.call(this)},pFa=function(a,b,c,d,e,f,h,l,m){switch(h.tagName){case "b":l.bold=!0;
break;case "i":l.fi=!0;break;case "u":l.underline=!0}for(var n=0;n<h.childNodes.length;n++){var p=h.childNodes[n];if(3===p.nodeType)p=new X1(b,c,d,e.id,p.nodeValue,f||0<n,g.Mb(l)?void 0:l),m.push(p),e.i.push(p);else{var r={};g.Qa(r,l);pFa(a,b,c,d,e,!0,p,r,m)}}},A2=function(a){var b=a.split(":");
a=0;b=g.q(b);for(var c=b.next();!c.done;c=b.next())a=60*a+Number(c.value);return 1E3*a},qFa=function(a,b,c,d){d=Object.assign({gp:0},d);
return new Y1(a,b,c,"_"+Z1++,d)},B2=function(a){g.C.call(this);
this.l=a;this.i=null},sFa=function(a){var b={};
if(a=K1(a))b.lang=a,rFa.test(a)&&(b.Qe=1);return b},E2=function(a){g.iO.call(this,a);
var b=this;this.F=a;this.l=this.F.P();this.videoData=this.F.getVideoData();this.Na=this.F.Ga();this.B={Cc:{}};this.C={Cc:{}};this.V=[];this.T={};this.ia={};this.U=!1;this.Ea=g.Yoa(this.videoData,this.F);this.Ta=!!this.videoData.captionTracks.length;this.Ua=!!this.videoData.kh;this.Fa="3"===this.l.controlsType;this.u=this.I=this.K=this.ha=this.Aa=null;this.wa=new B2(this.l);this.i=null;this.fa=new g.aO(this);var c=null,d=g.ho("yt-html5-player-modules::subtitlesModuleData");d&&(c=new g.Rn(d));this.storage=
c;c=a.jd();d=!(!c||!c.qs());this.Ha=!(!c||!c.rs());this.G=this.Fa&&d&&!this.Ea;this.ba=!this.G&&this.Fa&&this.Ha&&this.Ea;g.D(this,this.wa);this.G?this.da=this.Z=null:(this.Z=new g.hn(this.oH,void 0,this),g.D(this,this.Z),this.da=new g.I(this.gQ,2E3,this),g.D(this,this.da));g.D(this,this.fa);this.G||this.fa.L(a,"resize",this.AA);this.fa.L(a,"onPlaybackAudioChange",this.WM);this.fa.L(a,g.rG("captions"),function(e){b.ud(e)});
this.fa.L(a,g.sG("captions"),function(e){b.jf(e)});
C2(this,D2(this,"display-settings")||{})},tFa=function(a){if(1===a.l.ha||1===a.videoData.ao||"alwayson"===g.ZI(a.videoData,"yt:cc"))return!0;
if(2===a.l.ha){var b;g.vD(a.l)?b=(0,g.yCa)():b=D2(a,"module-enabled");if(null!=b)return!!b}if(a.videoData.captionTracks.length)var c=a.player.getAudioTrack().u;b=a.player.getAudioTrack().captionsInitialState;var d=g.ZI(a.videoData,"yt:cc");if(void 0===F2(a)){if("CAPTIONS_INITIAL_STATE_ON_RECOMMENDED"===b)return d?"on"===d:!0;if("CAPTIONS_INITIAL_STATE_OFF_RECOMMENDED"===b)return"on"===d}else return"on"===d;return"ON"===c||"on"===g.ZI(a.videoData,"yt:cc")},G2=function(a,b){if(a.i&&(void 0===b||!b)||
!a.videoData.captionTracks.length)return!1;
var c=a.player.getAudioTrack();return!!c.l||"FORCED_ON"===c.u},F2=function(a){var b=void 0,c=g.Yq(g.Wq.getInstance(),65);
if(g.vD(a.l)&&null!=c){if(null!=(0,g.yCa)())return!1;b=!c}return b},I2=function(a,b){if(a.u){if(a.I&&a.I.C)return a.I.C;
var c=b;c||(c=a.Ua?!1:a.Ta?!1:!0);c=L1(a.u.l,c);for(var d=[a.videoData.captionsLanguagePreference,a.l.captionsLanguagePreference,g.ZI(a.videoData,"yt:cc_default_lang")],e=0;e<d.length;e++)for(var f=0;f<c.length;f++)if(K1(c[f])===d[e])return c[f];return a.I&&a.I.B?a.I.B:(d=c.find(function(h){return h.isDefault}))?d:c[0]||H2(a)}return null},H2=function(a){return a.I&&a.I.l},J2=function(a){var b=H2(a);
return!!b&&a.i===b},uFa=function(a,b){for(var c=a.F.jd().ge().textTracks,d=a.i.toString(),e=0;e<c.length;e++){var f=c[e];
f.id===d&&(b?"showing"!==f.mode&&(f.mode="showing"):"showing"===f.mode&&(f.mode="disabled"))}},L2=function(a,b,c){a.loaded&&a.unload();
null!=c&&(a.U=c,a.U&&(g.vD(a.l)?(0,g.T_)(!!b):K2(a,"module-enabled",!!b)));a.i=b;G2(a)&&(a.i=H2(a));a.load()},vFa=function(a,b){var c=a.Na.getVideoContentRect(!0).height;
if(!c)return null;var d=a.i?a.i.languageCode:null;!b.params.Qe&&d&&rFa.test(d)&&(b.params.Qe=1);d=a.Na.getPlayerSize();switch(null!=b.params.gp?b.params.gp:1<b.i.length?1:0){case 1:return new V1(b,a.B,a.C,c,d.width,d.height,a.l.experiments);case 2:return new W1(b,a.B,a.C,c,d.width,d.height,a.l.experiments);default:return new U1(b,a.B,a.C,c,d.width,d.height,a.l.experiments)}},C2=function(a,b,c){c=void 0===c?!1:c;
var d=M2.Cc;a.B={};g.Qa(a.B,M2);a.B.Cc={};g.Qa(a.B.Cc,d);a.C={Cc:{}};var e=b.backgroundOverride?a.C:a.B,f=b.background||d.background;e2.test(f);e.Cc.background=f;e=b.colorOverride?a.C:a.B;f=b.color||d.color;e2.test(f);e.Cc.color=f;e=b.windowColorOverride?a.C:a.B;f=b.windowColor||M2.windowColor;e2.test(f);e.windowColor=f;e=b.backgroundOpacityOverride?a.C:a.B;f=b.backgroundOpacity;null==f&&(f=d.backgroundOpacity);e.Cc.backgroundOpacity=f;e=b.fontSizeIncrementOverride?a.C:a.B;f=b.fontSizeIncrement;null==
f&&(f=d.fontSizeIncrement);e.Cc.fontSizeIncrement=f;f=b.fontStyleOverride?a.C:a.B;e=b.fontStyle;null==e&&(e=d.bold&&d.fi?3:d.bold?1:d.fi?2:0);f=f.Cc;switch(e){case 1:f.bold=!0;delete f.fi;break;case 2:delete f.bold;f.fi=!0;break;case 3:f.bold=!0;f.fi=!0;break;default:delete f.bold,delete f.fi}e=b.textOpacityOverride?a.C:a.B;f=b.textOpacity;null==f&&(f=d.textOpacity);e.Cc.textOpacity=f;e=b.windowOpacityOverride?a.C:a.B;f=b.windowOpacity;null==f&&(f=M2.windowOpacity);e.windowOpacity=f;e=b.charEdgeStyleOverride?
a.C:a.B;f=b.charEdgeStyle;null==f&&(f=d.charEdgeStyle);e.Cc.charEdgeStyle=f;e=b.fontFamilyOverride?a.C:a.B;f=b.fontFamily;null==f&&(f=d.fontFamily);e.Cc.fontFamily=f;a.loaded&&a.AA();c&&K2(a,"display-settings",b)},xFa=function(a,b){if(b&&!a.K){var c=TEa({Qe:0,
lang:"en-GB"});a.K=[c,new X1(c.start,c.end-c.start,0,c.id,"Captions look like this")];a.player.Gd(a.K)}else!b&&a.K&&(wFa(a,a.K),a.K=null)},wFa=function(a,b){a.player.eg(b);
g.yb(b,function(c){g.ib(this.V,c)},a);
I1(a.Z)},D2=function(a,b){if(!a.storage)return null;
try{var c=a.storage.get(b)}catch(d){a.storage.remove(b)}return c},K2=function(a,b,c){if(a.storage)try{a.storage.set(b,c)}catch(d){}};
g.wO.prototype.tq=g.ca(23,function(){this.X();for(var a=g.oe(document,"track",void 0,this.i),b=0;b<a.length;b++)g.Ge(a[b])});
g.ES.prototype.tq=g.ca(22,function(){this.i.tq()});
g.wO.prototype.rs=g.ca(21,function(){return!(!this.i.textTracks||!this.i.textTracks.addEventListener)});
g.ES.prototype.rs=g.ca(20,function(){return this.i.rs()});
g.wO.prototype.qs=g.ca(19,function(){return!!this.i.textTracks});
g.ES.prototype.qs=g.ca(18,function(){return this.i.qs()});
g.wO.prototype.iq=g.ca(17,function(a){this.X();for(var b=0;b<a.length;b++)this.i.appendChild(a[b])});
g.ES.prototype.iq=g.ca(16,function(a){this.i.iq(a)});
g.Iy.prototype.St=g.ca(1,function(){return 0});
g.mz.prototype.St=g.ca(0,function(a){return(a=this.Wh(a))?a.l:0});
var rFa=/^(ar|ckb|dv|he|iw|fa|nqo|ps|sd|ug|ur|yi|.*[-_](Adlm|Arab|Hebr|Nkoo|Rohg|Thaa))(?!.*[-_](Latn|Cyrl)($|-|_))($|-|_)/i;g.u(N1,g.C);g.k=N1.prototype;g.k.lu=function(){};
g.k.mu=function(){};
g.k.Fk=function(){};
g.k.Lo=function(){return""};
g.k.iG=function(){return!1};
g.k.aa=function(){this.Fk();g.C.prototype.aa.call(this)};
g.u(O1,N1);O1.prototype.lu=function(a,b,c){var d=this;this.ka();b=this.Lo(a,b);this.Fk();this.i=g.Zp(b,{format:"RAW",onSuccess:function(e){d.i=null;c(e.responseText,a)},
withCredentials:!0})};
O1.prototype.mu=function(a){if(this.audioTrack)for(var b=g.q(this.audioTrack.captionTracks),c=b.next();!c.done;c=b.next())M1(this.l,c.value);a()};
O1.prototype.Lo=function(a,b){var c=a.url,d={fmt:b};if("srv3"===b||"3"===b||"json3"===b)g.hq()?Object.assign(d,{xorb:2,xobt:1,xovt:1}):Object.assign(d,{xorb:2,xobt:3,xovt:3});a.translationLanguage&&(d.tlang=K1(a));return g.Jp(c,d)};
O1.prototype.Fk=function(){this.i&&this.i.abort()};
P1.prototype.contains=function(a){a=g.tb(this.segments,a);return 0<=a||0>a&&1===(-a-1)%2};
P1.prototype.length=function(){return this.segments.length/2};
g.u(Q1,g.C);g.k=Q1.prototype;g.k.aa=function(){g.C.prototype.aa.call(this);this.l&&this.l.cancel()};
g.k.mB=function(){this.seekTo(this.player.getCurrentTime())};
g.k.seekTo=function(a){a-=this.player.oc();var b=this.i;this.i=g.Ya(this.U.ul(a).i);b!==this.i&&this.K&&this.K()};
g.k.reset=function(){this.B=new P1;this.l&&(this.l.cancel(),this.l=null)};
g.k.EE=function(){this.ka();var a;if(a=null!=this.i)a=this.i,a=a.i.Mk(a);!a||this.l||this.i&&30<this.i.startTime-this.player.getCurrentTime()||(a=this.i,a=a.i.Up(a),a.i[0].duration?(this.B.contains(a.i[0].na)||EEa(this,a),this.i=g.Ya(a.i)):!g.Q(this.T.experiments,"force_caption_seek_for_live_killswitch")&&this.i&&this.i.B&&this.i.B+this.player.oc()<this.player.getCurrentTime()&&this.seekTo(this.player.getCurrentTime()));this.I.start()};
g.u(R1,N1);g.k=R1.prototype;g.k.lu=function(a,b,c){var d=this;this.Fk();b=GEa(this,a.getId());b||(b=a.languageCode,b=this.i.isManifestless?HEa(this,b,"386"):HEa(this,b));if(b){var e=1E3*(b.index.St(b.index.Yh())-b.index.ff(b.index.Yh()));this.u=new Q1(new g.Ay,this.F,b,function(f,h){c(f,a,h,e)},this.G||g.tw(b.info),function(){d.u&&d.u.reset();
d.B=!0})}};
g.k.iG=function(){var a=this.B;this.B=!1;return a};
g.k.mu=function(a){var b=this.G?[new g.OH({id:"rawcc",languageCode:"rawcc",languageName:"CC1",is_servable:!0,is_default:!0,is_translateable:!1,vss_id:".en"}),new g.OH({id:"rawcc",languageCode:"rawcc",languageName:"CC3",is_servable:!0,is_default:!0,is_translateable:!1,vss_id:".en"})]:this.i.isManifestless?FEa(this,"386"):FEa(this);b=g.q(b);for(var c=b.next();!c.done;c=b.next())M1(this.l,c.value);a()};
g.k.Fk=function(){this.u&&(this.u.dispose(),this.u=null)};
g.k.Lo=function(){return""};
g.u(S1,N1);S1.prototype.lu=function(a,b,c){var d=this;this.ka();b=this.Lo(a,b);this.Fk();this.i=g.Zp(b,{format:"RAW",onSuccess:function(e){d.i=null;c(e.responseText,a)},
withCredentials:!0})};
S1.prototype.mu=function(a){var b=this,c=this.u,d={type:"list",tlangs:1,v:this.videoId,vssids:1};this.dE&&(d.asrs=1);c=g.Jp(c,d);this.Fk();this.i=g.Zp(c,{format:"RAW",onSuccess:function(e){b.i=null;if((e=e.responseXML)&&e.firstChild){for(var f=e.getElementsByTagName("track"),h=0;h<f.length;h++){var l=f[h],m=l.getAttribute("lang_code"),n=l.getAttribute("lang_translated"),p=l.getAttribute("name"),r=l.getAttribute("kind"),t=l.getAttribute("id"),w="true"===l.getAttribute("lang_default"),x="true"===l.getAttribute("cantran");
l=l.getAttribute("vss_id");M1(b.l,new g.OH({languageCode:m,languageName:n,name:p,kind:r,id:t,is_servable:!0,is_translateable:x,vss_id:l,is_default:w}))}e=e.getElementsByTagName("target");f=e.length;for(h=0;h<f;h++)m={languageCode:e[h].getAttribute("lang_code"),languageName:e[h].getAttribute("lang_translated"),languageOriginal:e[h].getAttribute("lang_original"),id:e[h].getAttribute("id"),isDefault:"true"===e[h].getAttribute("lang_default")},b.B[m.languageCode]=m.languageName,b.C.push(m)}a()},
withCredentials:!0})};
S1.prototype.Lo=function(a,b){var c=this.u,d={v:this.videoId,type:"track",lang:a.languageCode,name:a.getName(),kind:a.kind,fmt:b};a.translationLanguage&&(d.tlang=K1(a));return c=g.Jp(c,d)};
S1.prototype.Fk=function(){this.i&&this.i.abort()};
var e2=/^#(?:[0-9a-f]{3}){1,2}$/i,JEa=/#(.)(.)(.)/,IEa=/^#(?:[0-9a-f]{3}){1,2}$/i;var LEa=["left","right","center","justify"];g.u(U1,g.V);g.k=U1.prototype;g.k.kJ=function(a,b){var c=g.Jg(this.element,this.element.parentElement);this.Ea=a-c.x;this.Ha=b-c.y;g.K(this.element,"ytp-dragging")};
g.k.jJ=function(a,b){var c=g.Lg(this.element),d=a-this.Ea-.02*this.playerWidth,e=b-this.Ha-.02*this.playerHeight,f=(d+c.width/2)/this.maxWidth*3;f=Math.floor(g.Zd(f,0,2));var h=(e+c.height/2)/this.wa*3;h=Math.floor(g.Zd(h,0,2));var l=f+3*h;d=(d+f/2*c.width)/this.maxWidth;d=100*g.Zd(d,0,1);c=(e+h/2*c.height)/this.wa;c=100*g.Zd(c,0,1);this.l.params.Uh=l;this.l.params.Ci=c;this.l.params.Vg=d;this.i.Uh=l;this.i.Ci=c;this.i.Vg=d;this.EG()};
g.k.iJ=function(){g.sn(this.element,"ytp-dragging")};
g.k.EG=function(){this.Dp(this.C)};
g.k.Ab=function(){return this.type};
g.k.Dp=function(a){var b=Math.min(this.BD(),this.maxWidth),c=this.AD(),d="";3===this.l.params.Qe&&(d="rotate(180deg)");g.vg(this.element,{top:0,left:0,right:"",bottom:"",width:b?b+"px":"",height:c?c+"px":"","max-width":"96%","max-height":"96%",margin:"",transform:""});this.Uw(a);a={transform:d,top:"",left:"",width:b?b+"px":"",height:c?c+"px":"","max-width":"","max-height":""};var e=.96*this.i.Vg+2;d=this.i.Uh;switch(d){case 0:case 3:case 6:(b=this.i.Cc.fontSizeIncrement)&&0<b&&2!==this.i.Qe&&3!==
this.i.Qe&&(e=Math.max(e/(1+2*b),2));a.left=e+"%";break;case 1:case 4:case 7:a.left=e+"%";e=this.B.offsetWidth;b||e?(b=b||e+1,a.width=b+"px",a["margin-left"]=b/-2+"px"):a.transform+=" translateX(-50%)";break;case 2:case 5:case 8:a.right=100-e+"%"}b=.96*this.i.Ci+2;switch(d){case 0:case 1:case 2:a.top=b+"%";break;case 3:case 4:case 5:a.top=b+"%";(c=c||this.element.clientHeight)?(a.height=c+"px",a["margin-top"]=c/-2+"px"):a.transform+=" translateY(-50%)";break;case 6:case 7:case 8:a.bottom=100-b+"%"}g.vg(this.element,
a)};
g.k.Uw=function(a){var b;for(b=0;b<a.length&&a[b]===this.C[b];b++);if(this.Z||this.C.length>b)b=0,this.Z=!1,this.C=[],this.G=this.fa=this.ba=null,g.Ee(this.B);for(;b<a.length;b++)PEa(this,a[b])};
g.k.BD=function(){return 0};
g.k.AD=function(){return 0};
g.k.toString=function(){return g.V.prototype.toString.call(this)};g.u(V1,U1);V1.prototype.Uw=function(a){var b=this.l.i;U1.prototype.Uw.call(this,a);for(a=a.length;a<b.length;a++){var c=b[a];if(f&&c.i===e)var d=f;else{d={};g.Qa(d,c.i);g.Qa(d,yFa);var e=c.i;var f=d}PEa(this,c,d)}};
var yFa={LL:!0};g.u(W1,U1);g.k=W1.prototype;g.k.EG=function(){this.ia.Pg()};
g.k.MO=function(){g.sn(this.element,"ytp-rollup-mode");this.Dp(this.Ua,!0)};
g.k.AD=function(){return this.u?this.U:this.K};
g.k.BD=function(){return this.u?this.K:this.U};
g.k.Dp=function(a,b){this.Ua=a;if(this.l.params.wk){for(var c=0,d=0;d<this.C.length&&c<a.length;d++)this.C[d]===a[c]&&c++;0<c&&c<a.length&&(a=this.C.concat(a.slice(c)));this.Na=this.U;this.K=this.U=0;U1.prototype.Dp.call(this,a);SEa(this,b)}U1.prototype.Dp.call(this,a)};g.u(X1,g.oG);X1.prototype.toString=function(){return g.oG.prototype.toString.call(this)};g.u(Y1,g.oG);Y1.prototype.toString=function(){return g.oG.prototype.toString.call(this)};
var Z1=0;g.u($1,g.C);$1.prototype.u=function(){return[]};
$1.prototype.reset=function(){};g.u(a2,$1);a2.prototype.reset=function(){this.K={};this.l=this.i=null;this.I=!0};
a2.prototype.u=function(a,b){var c=a.firstChild;c.getAttribute("format");b=b||0;Number.isFinite(b);c=Array.from(c.childNodes);c=g.q(c);for(var d=c.next();!d.done;d=c.next())if(d=d.value,1===d.nodeType)switch(d.tagName){case "head":var e=d;break;case "body":var f=d}if(e)for(e=Array.from(e.childNodes),e=g.q(e),c=e.next();!c.done;c=e.next())if(c=c.value,1===c.nodeType)switch(c.tagName){case "pen":d=c.getAttribute("id");var h=this.B,l={},m=c.getAttribute("p");m&&g.Qa(l,this.B[m]);m=c2(c,"b");null!=m&&
(l.bold=m);m=c2(c,"i");null!=m&&(l.fi=m);m=c2(c,"u");null!=m&&(l.underline=m);m=d2(c,"et");null!=m&&(l.charEdgeStyle=m);m=d2(c,"of");null!=m&&(l.offset=m);m=f2(c,"bc");null!=m&&(l.background=m);m=f2(c,"ec");null!=m&&(l.hx=m);m=f2(c,"fc");null!=m&&(l.color=m);m=d2(c,"fs");null!=m&&0!==m&&(l.fontFamily=m);m=b2(c,"sz");void 0!==m&&(l.fontSizeIncrement=m/100-1);m=b2(c,"bo");void 0!==m&&(l.backgroundOpacity=m/255);m=b2(c,"fo");void 0!==m&&(l.textOpacity=m/255);m=d2(c,"rb");null!=m&&10!==m&&0!==m&&(l.xd=
10<m?m-1:m);c=d2(c,"hg");null!=c&&(l.YD=c);h[d]=l;break;case "ws":d=c.getAttribute("id");this.U[d]=WEa(this,c);break;case "wp":d=c.getAttribute("id"),this.T[d]=XEa(this,c)}if(f){e=b;c=[];f=Array.from(f.childNodes);f=g.q(f);for(d=f.next();!d.done;d=f.next())if(d=d.value,1===d.nodeType)switch(d.tagName){case "w":this.i=YEa(this,d,e,!1);(d=this.K[this.i.id])&&d.end>this.i.start&&(d.end=this.i.start);this.K[this.i.id]=this.i;c.push(this.i);break;case "p":var n=e;h=[];l=d.getAttribute("w")||this.G;m=!!c2(d,
"a");n=(b2(d,"t")||0)+n;var p=b2(d,"d")||5E3;m||(!this.I&&this.l&&this.l.windowId===l&&this.l.end>n&&(this.l.end=n),this.l&&"\n"===this.l.text&&(this.l.text=""));var r=m?6:5,t=d.getAttribute("p");t=t?this.B[t]:null;var w=Array.from(d.childNodes);w.length&&(this.I=null!=d.getAttribute("d"));for(var x=0;x<w.length;x++){var y=w[x],F=void 0;0<x&&(m=!0);var E=void 0;1===y.nodeType&&(E=y);if(E&&"s"===E.tagName){if((y=(y=E.getAttribute("p"))?this.B[y]:null)&&y.xd&&(1===y.xd?(y=w.slice(x,x+4),4===y.length&&
(F=VEa(n,p,l,m,r,y,this.B),x+=3)):F=VEa(n,p,l,m,r,[E],this.B)),!F){var G=E;F=n;E=p;y=l;var J=m,H=r,Aa=G.textContent?G.textContent:"",oa=G.getAttribute("p");oa=oa?this.B[oa]:null;G=b2(G,"t")||0;F=new X1(F+G,E-G,H,y,Aa,J,oa)}}else F=new X1(n,p,r,l,y.textContent||"",m,t);h.push(F);this.l=F}if(0<h.length)for(h[0].windowId===this.G&&(this.i=YEa(this,d,e,!0),c.push(this.i)),d=g.q(h),h=d.next();!h.done;h=d.next())h=h.value,h.windowId=this.i.id,this.i.i.push(h),c.push(h)}e=c}else e=[];return e};var zFa=new Map([[9,1],[10,1],[11,2],[12,3],[13,4],[14,5]]);g.u(g2,$1);g2.prototype.reset=function(){this.l.clear()};
g2.prototype.u=function(a,b){var c=JSON.parse(a);if(!c)return[];if(c.pens)for(var d=0,e=g.q(c.pens),f=e.next();!f.done;f=e.next()){f=f.value;var h={},l=f.pParentId;l&&Object.assign(h,this.i.get(l));f.bAttr&&(h.bold=!0);f.iAttr&&(h.fi=!0);f.uAttr&&(h.underline=!0);l=f.ofOffset;null!=l&&(h.offset=l);void 0!==f.szPenSize&&(h.fontSizeIncrement=f.szPenSize/100-1);l=f.etEdgeType;null!=l&&(h.charEdgeStyle=l);void 0!==f.ecEdgeColor&&(h.hx=h2(f.ecEdgeColor));l=f.fsFontStyle;null!=l&&0!==l&&(h.fontFamily=l);
void 0!==f.fcForeColor&&(h.color=h2(f.fcForeColor));void 0!==f.foForeAlpha&&(h.textOpacity=f.foForeAlpha/255);void 0!==f.bcBackColor&&(h.background=h2(f.bcBackColor));void 0!==f.boBackAlpha&&(h.backgroundOpacity=f.boBackAlpha/255);(l=f.rbRuby)&&10!==l&&(h.xd=10<l?l-1:l,h.Ai=zFa.get(h.xd));f.hgHorizGroup&&(h.YD=f.hgHorizGroup);this.i.set(d++,h)}if(c.wsWinStyles)for(d=0,e=g.q(c.wsWinStyles),f=e.next();!f.done;f=e.next())f=f.value,h={},(l=f.wsParentId)?Object.assign(h,this.C.get(l)):Object.assign(h,
this.G),void 0!==f.mhModeHint&&(h.gp=f.mhModeHint),void 0!==f.juJustifCode&&(h.textAlign=f.juJustifCode),void 0!==f.pdPrintDir&&(h.Qe=f.pdPrintDir),void 0!==f.sdScrollDir&&(h.iA=f.sdScrollDir),void 0!==f.wfcWinFillColor&&(h.windowColor=h2(f.wfcWinFillColor)),void 0!==f.wfoWinFillAlpha&&(h.windowOpacity=f.wfoWinFillAlpha/255),this.C.set(d++,h);if(c.wpWinPositions)for(d=0,e=g.q(c.wpWinPositions),f=e.next();!f.done;f=e.next())f=f.value,h={},(l=f.wpParentId)&&Object.assign(h,this.B.get(l)),void 0!==f.ahHorPos&&
(h.Vg=f.ahHorPos),void 0!==f.apPoint&&(h.Uh=f.apPoint),void 0!==f.avVerPos&&(h.Ci=f.avVerPos),void 0!==f.ccCols&&(h.Yk=f.ccCols),void 0!==f.rcRows&&(h.wk=f.rcRows),this.B.set(d++,h);if(c.events)for(d=[],c=g.q(c.events),e=c.next();!e.done;e=c.next()){var m=e.value;e=(m.tStartMs||0)+b;f=m.dDurationMs||0;if(m.id)h=String(m.id),e=ZEa(this,m,e,f,h),d.push(e),this.l.set(h,e);else{m.wWinId?h=m.wWinId.toString():(h="_"+Z1++,l=ZEa(this,m,e,f,h),d.push(l),this.l.set(h,l));0===f&&(f=5E3);l=this.l.get(h);var n=
!!m.aAppend,p=n?6:5,r=m.segs,t=null;m.pPenId&&(t=this.i.get(m.pPenId));for(m=0;m<r.length;m++){var w=r[m],x=w.utf8;if(x){var y=w.tOffsetMs||0,F=null;w.pPenId&&(F=this.i.get(w.pPenId));if(2===(null!=l.params.gp?l.params.gp:1<l.i.length?1:0)&&n&&"\n"===x)continue;if(w=F&&1===F.xd)if(w=m,w+3>=r.length||!r[w+1].pPenId||!r[w+2].pPenId||!r[w+3].pPenId)w=!1;else{var E=r[w+1].pPenId;(E=this.i.get(E))&&E.xd&&2===E.xd?(E=r[w+2].pPenId,E=this.i.get(E),!E||!E.xd||3>E.xd?w=!1:(E=r[w+3].pPenId,w=(E=this.i.get(E))&&
E.xd&&2===E.xd?!0:!1)):w=!1}if(w){y=r[m+1].utf8;w=r[m+3].utf8;E=r[m+2].utf8;var G=this.i.get(r[m+2].pPenId);x=UEa(x,y,E,w,G);n=new X1(e,f,p,h,x,n,F);m+=3}else n=new X1(e+y,f-y,p,l.id,x,n,F||t);n&&(d.push(n),l.i.push(n))}n=!0}}}else d=[];return d};j2.prototype.clear=function(){this.u=this.time=this.mode=0;this.i=[];this.reset()};
j2.prototype.reset=function(){this.mode=0;this.B.reset(0);this.C.reset(1)};
var $Ea=[128,1,2,131,4,133,134,7,8,137,138,11,140,13,14,143,16,145,146,19,148,21,22,151,152,25,26,155,28,157,158,31,32,161,162,35,164,37,38,167,168,41,42,171,44,173,174,47,176,49,50,179,52,181,182,55,56,185,186,59,188,61,62,191,64,193,194,67,196,69,70,199,200,73,74,203,76,205,206,79,208,81,82,211,84,213,214,87,88,217,218,91,220,93,94,223,224,97,98,227,100,229,230,103,104,233,234,107,236,109,110,239,112,241,242,115,244,117,118,247,248,121,122,251,124,253,254,127,0,129,130,3,132,5,6,135,136,9,10,139,
12,141,142,15,144,17,18,147,20,149,150,23,24,153,154,27,156,29,30,159,160,33,34,163,36,165,166,39,40,169,170,43,172,45,46,175,48,177,178,51,180,53,54,183,184,57,58,187,60,189,190,63,192,65,66,195,68,197,198,71,72,201,202,75,204,77,78,207,80,209,210,83,212,85,86,215,216,89,90,219,92,221,222,95,96,225,226,99,228,101,102,231,232,105,106,235,108,237,238,111,240,113,114,243,116,245,246,119,120,249,250,123,252,125,126,255];k2.prototype.set=function(a){this.type=a};
k2.prototype.get=function(){return this.type};
l2.prototype.clear=function(){this.state=0};
l2.prototype.update=function(){this.state=2===this.state?1:0};
l2.prototype.isValid=function(){return 0!==this.state};
l2.prototype.matches=function(a,b){return this.isValid()&&a===this.Hm&&b===this.Uk};
eFa.prototype.reset=function(){this.timestamp=this.i=0};
m2.prototype.updateTime=function(a){for(var b=1;15>=b;++b)for(var c=1;32>=c;++c)this.u[b][c].timestamp=a};
m2.prototype.debugString=function(){for(var a="\n",b=1;15>=b;++b){for(var c=1;32>=c;++c){var d=this.u[b][c];a=0===d.i?a+"_":a+String.fromCharCode(d.i)}a+="\n"}return a};
m2.prototype.reset=function(a){for(var b=0;15>=b;b++)for(var c=0;32>=c;c++)this.u[b][c].reset();this.B=a;this.i=0;this.l=this.row=1};
var fFa=[32,33,34,35,36,37,38,39,40,41,225,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,233,93,237,243,250,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,231,247,209,241,9632],gFa=[174,176,189,191,8482,162,163,9834,224,32,232,226,234,238,244,251],hFa=[193,201,211,218,220,252,8216,161,42,39,9473,169,8480,183,8220,8221,192,194,199,200,202,203,235,
206,207,239,212,217,249,219,171,187],iFa=[195,227,205,204,236,210,242,213,245,123,125,92,94,95,124,126,196,228,214,246,223,165,164,9475,197,229,216,248,9487,9491,9495,9499];s2.prototype.reset=function(a,b){this.C=b;this.style.set(2);this.l=this.G;this.B=this.I;this.i=this.l;var c=(a<<2)+(b<<1);this.G.reset(c);this.I.reset(c);this.text.reset((a<<2)+(b<<1)+1)};
i2.prototype.reset=function(a){this.C=a;this.l.clear();this.B=this.u;this.u.reset(a,0);this.G.reset(a,1)};nFa.prototype.B=function(){};g.u(u2,nFa);u2.prototype.B=function(a,b,c,d,e){if(c<d){var f="_"+Z1++;c=c/1E3-this.G;d=d/1E3-this.G;a=new Y1(c,d-c,5,f,{textAlign:0,Uh:0,Vg:2.5*b,Ci:5.33*a});e=new X1(c,d-c,5,f,e);this.l.push(a);this.l.push(e)}};
g.u(x2,$1);x2.prototype.u=function(a){a=new u2(a,a.byteLength,this.l);if(oFa(a)){for(;a.byteOffset<a.i.byteLength;)for(0===a.version?a.u=w2(a)*(1E3/45):1===a.version&&(a.u=4294967296*w2(a)+w2(a)),a.C=v2(a);0<a.C;a.C--){var b=v2(a),c=v2(a),d=v2(a);b&4&&(b&3)===this.track&&(0===this.track||1===this.track)&&(b=this.i,b.i.push({time:a.u,type:this.track,DC:c,EC:d,order:b.i.length}))}dFa(this.i,a);return a.l}return[]};
x2.prototype.reset=function(){this.i.clear()};g.u(z2,$1);
z2.prototype.u=function(a,b){for(var c=[],d=a.split(AFa),e=1;e<d.length;e++){var f=d[e],h=b;if(""!==f&&!BFa.test(f)){var l=N2.exec(f);if(l&&4<=l.length){var m=A2(l[1]),n=A2(l[2])-m;m+=h;var p=(l=l[3])?l.split(" "):[];l={};var r=null,t="",w=null,x="";l.textAlign=2;p=g.q(p);for(var y=p.next();!y.done;y=p.next())if(y=y.value.split(":"),2===y.length){var F=y[1];switch(y[0]){case "line":y=F.split(",");y[0].endsWith("%")&&(r=y[0],l.Ci=Number.parseInt(r,10),2===y.length&&(t=y[1].trim()));break;case "position":y=
F.split(",");w=y[0];l.Vg=Number.parseInt(w,10);2===y.length&&(x=y[1].trim());break;case "align":switch(F){case "start":l.textAlign=0;break;case "middle":l.textAlign=2;break;case "end":l.textAlign=1}}}r||(l.Ci=100,t||(t="end"));if(!w)switch(l.textAlign){case 0:l.Vg=0;break;case 1:l.Vg=100;break;default:l.Vg=50}r=0;switch(t){case "center":r+=3;break;case "end":r+=6;break;default:r+=0}switch(x){case "line-left":r+=0;break;case "center":r+=1;break;case "line-right":r+=2;break;default:switch(l.textAlign){case 0:r+=
0;break;case 2:r+=1;break;case 1:r+=2}}l.Uh=0>r||8<r?7:r;f=f.substring(N2.lastIndex).replace(/[\x01-\x09\x0b-\x1f]/g,"");x=l;l=f;f={};if(0>l.indexOf("<")&&0>l.indexOf("&"))h=qFa(m,n,5,x),n=new X1(m,n,5,h.id,l,!1,g.Mb(f)?void 0:f),c.push(h),c.push(n),h.i.push(n);else for(t=l.split(CFa),1===t.length?(l=5,x=qFa(m,n,l,x)):(r=l=6,x=Object.assign({Yk:32},x),x=new Y1(m,n,r,"_"+Z1++,x)),c.push(x),r=m,w=0;w<t.length;w++)p=t[w],0===w%2?(y=g.t_("<html>"+p+"</html>"),y.getElementsByTagName("parsererror").length?
(F=y.createElement("span"),F.appendChild(y.createTextNode(p))):F=y.firstChild,pFa(this,r,n-(r-m),l,x,0<w,F,f,c)):r=A2(p)+h}N2.lastIndex=0}}return c};
var BFa=/^NOTE/,AFa=/(?:\r\n|\r|\n){2,}/,N2=RegExp("^((?:[\\d]{2}:)?[\\d]{2}:[\\d]{2}\\.[\\d]{3})[\\t ]+--\x3e[\\t ]+((?:[\\d]{2}:)?[\\d]{2}:[\\d]{2}\\.[\\d]{3})(?:[\\t ]*)(.*)(?:\\r\\n|\\r|\\n)","gm"),CFa=/<((?:[\d]{2}:)?[\d]{2}:[\d]{2}\.[\d]{3})>/;g.u(B2,g.C);B2.prototype.clear=function(){this.i&&this.i.dispose();this.i=null};
B2.prototype.reset=function(){this.i&&this.i.reset()};
B2.prototype.aa=function(){g.C.prototype.aa.call(this);this.clear()};var M2={windowColor:"#080808",windowOpacity:0,textAlign:2,Uh:7,Vg:50,Ci:100,Cc:{background:"#080808",backgroundOpacity:.75,charEdgeStyle:0,color:"#fff",fontFamily:4,fontSizeIncrement:0,textOpacity:1,offset:1}};g.u(E2,g.iO);g.k=E2.prototype;g.k.aa=function(){if(this.G||this.ba){var a=this.F.jd();a&&!a.ka()&&a.tq()}else xFa(this,!1);g.iO.prototype.aa.call(this)};
g.k.Fn=function(){if(this.Fa)return this.G||this.ba;var a=this.player.getAudioTrack().captionsInitialState;return"CAPTIONS_INITIAL_STATE_ON_REQUIRED"===a?!0:"CAPTIONS_INITIAL_STATE_OFF_REQUIRED"===a?G2(this):F2(this)||G2(this)?!0:tFa(this)};
g.k.load=function(){var a=this;g.iO.prototype.load.call(this);var b=!g.Q(this.l.experiments,"web_player_captions_track_list_changed_killswitch");this.I=this.player.getAudioTrack();if(this.u)this.i&&(this.wa.clear(),this.G?uFa(this,!0):3!==this.player.getPresentingPlayerType()&&this.u.lu(this.i,"json3",function(d,e,f,h){if(d){a.u.iG()&&(a.V=[],a.F.Me("captions"),I1(a.Z),a.wa.reset());var l=a.wa;f=f||0;h=h||0;if(l.l.W("html5_disable_rawcc_killswitch")){if("string"!==typeof d){var m=new DataView(d);
8<=m.byteLength&&1718909296===m.getUint32(4)&&(m=g.gv(m,0,1835295092),d=d.slice(m.dataOffset,m.dataOffset+m.size),y2(d)||(d=g.Te(new Uint8Array(d))))}}else"string"===typeof d||y2(d)||(m=new DataView(d),d=8>=m.byteLength||1718909296!==m.getUint32(4)?"":(m=g.gv(m,0,1835295092))&&m.size?g.Te(new Uint8Array(d.slice(m.dataOffset,m.dataOffset+m.size))):"");if(d)try{if("string"!==typeof d){var n=d,p=f,r=h;if(!y2(n))throw Error("Invalid binary caption track data");l.i||(l.i=new x2(r,e));var t=l.i.u(n,p)}else{if("WEBVTT"===
d.substring(0,6))e=d,r=f,l.i||(l.i=new z2),p=l.i.u(e,r),.01>Math.random()&&g.kt(Error("Deprecated subtitles format in web player: WebVTT")),n=p;else b:{p=d;if("{"===p[0])try{l.i||(l.i=new g2(sFa(e)));n=l.i.u(p,f);break b}catch(G){g.jt(G);n=[];break b}r=g.t_(p);if(!r||!r.firstChild){var w=Error("Invalid caption track data");w.params=p;throw w;}if("timedtext"===r.firstChild.tagName){if(3===Number(r.firstChild.getAttribute("format"))){l.i||(l.i=new a2(sFa(e),l.l));n=l.i.u(r,f);break b}var x=Error("Unsupported subtitles format in web player (Format2)");
x.params=p;throw x;}if("transcript"===r.firstChild.tagName){var y=Error("Unsupported subtitles format in web player (Format1)");y.params=p;throw y;}var F=Error("Invalid caption track data");F.params=p;throw F;}t=n}var E=t}catch(G){g.jt(G),l.clear(),E=[]}else E=[];a.player.Gd(E);!a.U||a.ba||J2(a)||g.eD(a.l)||g.WC(a.l)||(g.mn(a.da),E=TEa({Uh:0,Vg:5,Ci:5,wk:2,textAlign:0,Qe:0,lang:"en-GB"}),a.ha=[E],l=["Click "," for settings"],a.Aa||(t=new g.RL(g.fM()),g.D(a,t),a.Aa=t.element),t=E.end-E.start,(e=g.PH(a.i))&&
a.ha.push(new X1(E.start,t,0,E.id,e)),a.ha.push(new X1(E.start,t,0,E.id,l[0]),new X1(E.start,t,0,E.id,a.Aa,!0),new X1(E.start,t,0,E.id,l[1],!0)),a.player.Gd(a.ha),g.ln(a.da));!a.U||a.ba||J2(a)||(g.vD(a.l)?(0,g.T_)(!0):K2(a,"module-enabled",!0),a.I&&(a.I.C=a.i),a.player.Nn());a.U=!1}}),!b||this.G||this.ba||J2(this)||this.player.ra("captionschanged",J1(this.i))),b||(this.i&&!J2(this)?this.player.ra("captionschanged",J1(this.i)):this.player.ra("onCaptionsTrackListChanged"));
else{var c;this.Ea?c=new R1(this.videoData.i,this.player):this.Ta?c=new O1(this.l,this.videoData,this.player.getAudioTrack()):c=new S1(this.videoData.kh,this.videoData.videoId,this.videoData.captionsLanguagePreference||this.l.captionsLanguagePreference||g.ZI(this.videoData,"yt:cc_default_lang")||this.l.fd,this.videoData.HA,this.l);this.u=c;g.D(this,this.u);c.mu(function(){var d=a.player.getAudioTrack().captionsInitialState,e;"CAPTIONS_INITIAL_STATE_UNKNOWN"===d?F2(a)||a.U||tFa(a)?e=I2(a,a.U):G2(a)&&
(e=H2(a)):"CAPTIONS_INITIAL_STATE_ON_REQUIRED"===d?e=I2(a,a.U):"CAPTIONS_INITIAL_STATE_OFF_REQUIRED"===d&&G2(a)&&(e=H2(a));if(a.G||a.ba){var f=L1(a.u.l,!0);d=[];for(var h=0;h<f.length;h++){var l=f[h],m=g.Ce("TRACK");m.setAttribute("kind","subtitles");m.setAttribute("label",g.PH(l));m.setAttribute("srclang",K1(l));m.setAttribute("id",l.toString());a.ba||m.setAttribute("src",a.u.Lo(l,"vtt"));l===e&&m.setAttribute("default","1");d.push(m)}e=a.F.jd();e.iq(d);e=e.ge();a.Ha&&a.fa.L(e.textTracks,"change",
a.qP)}else!a.i&&e&&L2(a,e),a.player.ra("onCaptionsTrackListChanged"),a.player.ra("onApiChange")})}};
g.k.unload=function(){this.G&&this.i?uFa(this,!1):(this.da&&g.mn(this.da),this.player.Me("captions"),this.V=[],this.u&&this.u.Fk(),this.wa.clear(),this.K&&this.player.Gd(this.K),this.AA());g.iO.prototype.unload.call(this);this.player.Nn();this.player.ra("captionschanged",{})};
g.k.create=function(){this.Fn()&&this.load()};
g.k.qP=function(){for(var a=this.F.jd().ge().textTracks,b=null,c=0;c<a.length;c++)if("showing"===a[c].mode)a:{b=a[c].id;var d=L1(this.u.l,!0);for(var e=0;e<d.length;e++)if(d[e].toString()===b){b=d[e];break a}b=null}(this.loaded?this.i:null)!==b&&L2(this,b,!0)};
g.k.XQ=function(){!this.i&&this.G||this.unload()};
g.k.ud=function(a){this.V.push(a);I1(this.Z)};
g.k.jf=function(a){g.ib(this.V,a);this.u instanceof R1&&this.u.G&&this.player.eg([a]);I1(this.Z)};
g.k.ZP=function(a){if(a instanceof Y1){var b=this.T[a.id];b&&b.l!==a&&(b.dispose(),delete this.T[a.id],b=null);b||(b=vFa(this,a))&&(this.T[a.id]=b)}else b=a.windowId,this.ia[b]||(this.ia[b]=[]),this.ia[b].push(a)};
g.k.gQ=function(){wFa(this,this.ha);this.ha=null};
g.k.oH=function(){var a=this;this.Z.stop();g.Nb(this.ia);this.V.sort(g.qG);var b=this.V;if(this.K){var c=g.He(b,function(d){return-1===this.K.indexOf(d)},this);
c.length&&(b=c)}g.yb(b,this.ZP,this);g.Ab(this.T,function(d,e){a.ia[e]?(d.element.parentNode||(d instanceof W1||d instanceof V1||g.Db(a.T,function(f,h){h!==e&&f.l.params.Uh===d.l.params.Uh&&f.l.params.Vg===d.l.params.Vg&&f.l.params.Ci===d.l.params.Ci&&(f.dispose(),delete a.T[h]);return h===e},a),g.ZN(a.player,d.element,4)),d.Dp(a.ia[e])):(d.dispose(),delete a.T[e])},this)};
g.k.kQ=function(){C2(this,{},!0);g.Q(this.l.experiments,"web_player_disable_publish_captions_settings_changed_on_reset")||this.player.ra("captionssettingschanged")};
g.k.lL=function(){var a=M2.Cc;a={background:a.background,backgroundOpacity:a.backgroundOpacity,charEdgeStyle:a.charEdgeStyle,color:a.color,fontFamily:a.fontFamily,fontSizeIncrement:a.fontSizeIncrement,fontStyle:a.bold&&a.fi?3:a.bold?1:a.fi?2:0,textOpacity:a.textOpacity,windowColor:M2.windowColor,windowOpacity:M2.windowOpacity};var b=D2(this,"display-settings")||{};null!=b.background&&(a.background=b.background);null!=b.backgroundOverride&&(a.backgroundOverride=b.backgroundOverride);null!=b.backgroundOpacity&&
(a.backgroundOpacity=b.backgroundOpacity);null!=b.backgroundOpacityOverride&&(a.backgroundOpacityOverride=b.backgroundOpacityOverride);null!=b.charEdgeStyle&&(a.charEdgeStyle=b.charEdgeStyle);null!=b.charEdgeStyleOverride&&(a.charEdgeStyleOverride=b.charEdgeStyleOverride);null!=b.color&&(a.color=b.color);null!=b.colorOverride&&(a.colorOverride=b.colorOverride);null!=b.fontFamily&&(a.fontFamily=b.fontFamily);null!=b.fontFamilyOverride&&(a.fontFamilyOverride=b.fontFamilyOverride);null!=b.fontSizeIncrement&&
(a.fontSizeIncrement=b.fontSizeIncrement);null!=b.fontSizeIncrementOverride&&(a.fontSizeIncrementOverride=b.fontSizeIncrementOverride);null!=b.fontStyle&&(a.fontStyle=b.fontStyle);null!=b.fontStyleOverride&&(a.fontStyleOverride=b.fontStyleOverride);null!=b.textOpacity&&(a.textOpacity=b.textOpacity);null!=b.textOpacityOverride&&(a.textOpacityOverride=b.textOpacityOverride);null!=b.windowColor&&(a.windowColor=b.windowColor);null!=b.windowColorOverride&&(a.windowColorOverride=b.windowColorOverride);
null!=b.windowOpacity&&(a.windowOpacity=b.windowOpacity);null!=b.windowOpacityOverride&&(a.windowOpacityOverride=b.windowOpacityOverride);return a};
g.k.vH=function(a,b){var c={};g.Qa(c,D2(this,"display-settings"));g.Qa(c,a);C2(this,c,b);this.player.ra("captionssettingschanged")};
g.k.AA=function(){!this.G&&this.loaded&&(g.Ab(this.T,function(a,b){a.dispose();delete this.T[b]},this),this.oH())};
g.k.Ee=function(a,b){switch(a){case "fontSize":if(isNaN(b))break;var c=g.Zd(b,-2,4);this.vH({fontSizeIncrement:c});return c;case "reload":b&&!this.G&&L2(this,this.i,!0);break;case "stickyLoading":void 0!==b&&this.l.u&&(g.vD(this.l)?(0,g.T_)(!!b):K2(this,"module-enabled",!!b));break;case "track":if(!this.u)return{};if(b){if(this.G)break;if(!g.Ma(b))break;if(g.Mb(b)){L2(this,null,!0);break}for(var d=L1(this.u.l,!0),e=0;e<d.length;e++){var f=d[e];f.languageCode!==b.languageCode||c&&f.languageName!==
b.languageName||(c=b.translationLanguage?AEa(f,b.translationLanguage):f)}!c||c===this.i&&this.loaded||L2(this,c,!0)}else return this.loaded&&this.i&&!J2(this)?J1(this.i):{};return"";case "tracklist":return this.u?g.Jc(L1(this.u.l,!(!b||!b.includeAsr)),function(h){return J1(h)}):[];
case "translationLanguages":return this.u?this.u.C.map(function(h){return Object.assign({},h)}):[];
case "sampleSubtitles":this.G||void 0===b||xFa(this,!!b)}};
g.k.getOptions=function(){var a="reload fontSize track tracklist translationLanguages sampleSubtitle".split(" ");this.l.u&&a.push("stickyLoading");return a};
g.k.iy=function(){var a=this.i;return a?{cc:a.vssId}:{}};
g.k.MQ=function(){this.loaded&&this.i&&!J2(this)?(g.vD(this.l)?(0,g.T_)(!1):K2(this,"module-enabled",!1),this.unload(),G2(this,!0)&&L2(this,H2(this),!1)):L2(this,J2(this)||!this.i?I2(this,!0):this.i,!0)};
g.k.WM=function(){var a=J2(this);G2(this,a)?L2(this,this.player.getAudioTrack().l,!1):this.videoData.captionTracks.length&&(this.loaded&&this.unload(),this.Fn()&&(a?L2(this,I2(this),!1):this.load()))};g.oO.captions=E2;})(_yt_player);
